<template>
  <q-page class="q-pl-md bg-grey-1 splitscreen" role="presentation">
    <q-splitter class="splitscreen__splitter" v-model="panelWidth" :limits="[50,100]">
      <template v-slot:before>
        <div v-if="reference" role="region" aria-label="Referentie">
          <ReferenceDetailCard
            :reference="reference"
            :dts_name="dts_name"
            :nt_version="nt_version"
            v-on:conceptClicked="concept_clicked"></ReferenceDetailCard>
        </div>
      </template>

      <template v-slot:separator>
      </template>
      <template v-slot:after>
        <div v-if="node" role="region" aria-label="Detail gekozen cell">
          <CellValue :node="node" v-on:close_detail="close_detail"></CellValue>
        </div>
      </template>
    </q-splitter>
  </q-page>
</template>

<script>
import {api} from 'boot/axios'
import CellValue from "components/CellValue";
import SharedMethods from "components/SharedMethods";
import ReferenceDetailCard from "components/ReferenceDetailCard";

export default {
  name: "ReferenceDetail",
  components: {ReferenceDetailCard, CellValue},
  props: {
    reference_id: String,
    dts_name: String,
    nt_version: String,
  },
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
  },
  data() {
    return {
      reference: undefined,
      node: undefined,
      panelWidth: 50,
    }
  },
  mounted() {
    if (this.reference_id && this.dts_name) {
      this.fetchData()
    }
  },
  watch: {
    reference_id: function () {
      this.fetchData()
    }
  },
  methods: {
    fetchData: function () {
      if (this.reference_id) {
        api
          .get("/dts/" + this.dts_name + '/references/' + this.reference_id,
            {params: {nt_version: this.nt_version}})
          .then(response => {
            this.reference = response.data[0]
          })
      }
    },
    concept_clicked: function (concept) {
      this.node = {concept: concept}
      if (this.panelWidth === 100) {
        this.panelWidth = 50
      }
    },
    close_detail: function () {
      this.panelWidth = 100
    }
  }
}
</script>

<style scoped lang="scss">

.splitscreen__splitter {
  height: calc(100vh - 150px);
  width: 98%;
}

.value {
  border-radius: 5px;
  padding: 5px 0 5px 10px;
}

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

table {
  border-spacing: 5px;
  width: 100%;
}

th {
  text-align: left;
}

td.tiny {
  width: 10%;
}
</style>
